/*
 *****************************************************************************
 *                                                                           *
 *              IMPINJ CONFIDENTIAL AND PROPRIETARY                          *
 *                                                                           *
 * This source code is the sole property of Impinj, Inc. Reproduction or     *
 * utilization of this source code in whole or in part is forbidden without  *
 * the prior written consent of Impinj, Inc.                                 *
 *                                                                           *
 * (c) Copyright Impinj, Inc. 2013-2015. All rights reserved.                *
 *                                                                           *
 *****************************************************************************/

#ifndef _PLATFORM_H
#define _PLATFORM_H
#include <stdint.h>

#include "iri.h"

#ifdef __cplusplus
extern "C" {
#endif

#define PLATFORM_DEFAULT_WRITE_TIMEOUT_MS   IPJ_DEFAULT_TRANSMIT_TIMEOUT_MS
#define PLATOFRM_DEFAULT_READ_TIMEOUT_MS    IPJ_DEFAULT_RECEIVE_TIMEOUT_MS

uint32_t platform_open_port_handler(
        IPJ_READER_CONTEXT* reader_context,
        IPJ_READER_IDENTIFIER reader_identifier,
        ipj_connection_type connection_type,
        ipj_connection_params* params);
uint32_t platform_close_port_handler(IPJ_READER_CONTEXT reader_context);
uint32_t platform_transmit_handler(
        IPJ_READER_CONTEXT reader_context,
        uint8_t* message_buffer,
        uint16_t buffer_size,
        uint16_t* number_bytes_written);
uint32_t platform_receive_handler(
        IPJ_READER_CONTEXT reader_context,
        uint8_t* message_buffer,
        uint16_t buffer_size,
        uint16_t* number_bytes_received,
        uint16_t timeout_ms);
uint32_t platform_timestamp_ms_handler(void);
uint32_t platform_flush_port_handler(IPJ_READER_CONTEXT reader_context);
uint32_t platform_modify_connection_handler(
        IPJ_READER_CONTEXT reader_context,
        ipj_connection_type connection_type,
        ipj_connection_params* params);
void     platform_sleep_ms_handler(uint32_t milliseconds);
uint32_t platform_reset_pin_handler(IPJ_READER_CONTEXT reader_context, bool enable);
uint32_t platform_wakeup_pin_handler(IPJ_READER_CONTEXT reader_context, bool enable);

#ifdef __cplusplus
}
#endif

#endif // _PLATFORM_H
